package si.mojeznanje;

import org.apache.log4j.Logger;
import org.glassfish.grizzly.http.server.HttpServer;
import org.glassfish.jersey.grizzly2.httpserver.GrizzlyHttpServerFactory;
import org.glassfish.jersey.jackson.JacksonFeature;
import org.glassfish.jersey.server.ResourceConfig;
import si.mojeznanje.model.Lokacija;
import si.mojeznanje.model.OgradaSet;
import si.mojeznanje.model.Pes;
import si.mojeznanje.model.Zival;
import si.mojeznanje.service.ZapisovalecHibernate;
import si.mojeznanje.service.datoteka.ZapisovalecXML;
import si.mojeznanje.service.ip.IpApiJersey;
import si.mojeznanje.service.rest.OgradaService;
import si.mojeznanje.service.rest.TestService;
import si.mojeznanje.service.rest.ZivaliService;
import si.mojeznanje.util.HibernateUtil;
import si.mojeznanje.view.VnosPodatkov;

import javax.persistence.criteria.CriteriaBuilder;
import javax.ws.rs.core.UriBuilder;
import javax.xml.bind.JAXB;
import javax.xml.bind.JAXBContext;
import java.net.URI;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

//https://we.tl/M4JntDZpQY
// baza : https://we.tl/LQzqBD4iqz
public class Main {

    private static HttpServer httpServer = null;

    public static void main(String[] args) {

        zacniStreznik();


      /*  Integer pogoj1 = 5;
        Integer pogoj2= 1;

        Zival pes = new Pes();
        Zival pes2 = pes;

        pes.setIme("Rexi");

        System.out.println(pes2.getIme());

        if(pogoj1 < 0 && pogoj1 > 1){

        }
        else if(pogoj1.equals(0)){

        }
        else {

        }

        List<Integer> stevila = new ArrayList<>();

        while (pogoj1 >= 0){
            pogoj1 -= 1;
        }

        for(Integer st : stevila){
            st.toString();
        }

        for(int i = 0; i < 5; i++){

        }
*/
    }


    protected static void dates(){

        Long unixTime = System.currentTimeMillis();
        Date date = new Date(0);

        SimpleDateFormat df = new SimpleDateFormat("dd.MM 'ob' HH:ss");

        Calendar calendar = Calendar.getInstance();;
        calendar.setTimeInMillis(unixTime);

        calendar.add(Calendar.DATE,-1);
        calendar.add(Calendar.MONTH, 10);

        Integer danVTednu = calendar.get(Calendar.DAY_OF_WEEK);
        Integer mesec = calendar.get(Calendar.MONTH);
        Integer ura = calendar.get(Calendar.HOUR_OF_DAY);

        if(danVTednu == Calendar.WEDNESDAY){
            System.out.println("danes je sreda");
        }

        Long novMillisTime = calendar.getTimeInMillis();
        Date novDatum = calendar.getTime();

        System.out.println(df.format(novDatum));

    }
    protected static void numbers(){

        int interger = 0;
        long lon = 0l;
        double dub = 0.5d;
        float fl = 0.5f;

        interger = (int) lon;
        dub = interger;
        interger = (int) dub;

        Integer intt = Integer.parseInt("55");
        Long llong = 0l;
        Double ddub = 0d;
        Float floa = 532434.4243423423423f;
        interger = floa.intValue();

        DecimalFormat df = new DecimalFormat("$###,###.##");


        System.out.println(df.format(floa));

    }

    protected static void strings(){

        String pozdrav = "Lep pozdravček";
        pozdrav = pozdrav + " vsem";

        Integer index =  pozdrav.indexOf("pozdrav");

        //pozdrav = pozdrav.replace("Lep","Zelo lep");

        //pozdrav = pozdrav.replaceAll("[^A-Za-z]", "");

        //pozdrav = pozdrav.substring(4);

        pozdrav = pozdrav.substring(4, 14);

        System.out.println(pozdrav);
    }

    protected static void zacniStreznik(){
        Logger logger = Logger.getLogger(Main.class);

        logger.info("Program se zacenja");


        httpServer = startServer();

        Runtime.getRuntime().addShutdownHook(new Thread(
                new Runnable() {
                    @Override
                    public void run() {
                        httpServer.shutdown();
                        HibernateUtil.shutdown();
                        System.exit(0);
                    }
                }
        ));
    }

    private static void pretvoriVXmlTest() {


        ZapisovalecHibernate zapisovalec = new ZapisovalecHibernate();

        OgradaSet ograda = zapisovalec.preberi(OgradaSet.class, 2);

        ZapisovalecXML<OgradaSet> xml = new ZapisovalecXML<OgradaSet>(OgradaSet.class, "ograda.xml");

        xml.shrani(ograda);
    }

    private static void preberiIzXml(){

        OgradaSet ograda = null;

        ZapisovalecXML<OgradaSet> xml = new ZapisovalecXML<OgradaSet>(OgradaSet.class, "ograda.xml");

        ograda = xml.preberi();

    }

    private static URI getBaseURI(){
        return UriBuilder.fromUri("http://0.0.0.0/").port(8080).build();
    }

    public static HttpServer startServer(){

        HttpServer httpServer = null;
        ResourceConfig resourceConfig = new ResourceConfig();
        resourceConfig.registerClasses(TestService.class,
                ZivaliService.class,
                OgradaService.class);

        resourceConfig.register(JacksonFeature.class);

        try {
            httpServer = GrizzlyHttpServerFactory.createHttpServer(getBaseURI(), resourceConfig,true);
        }
        catch (Exception e){
            System.out.println("Napaka pri kreaciji strznika");
        }

        return httpServer;
    }

    public static void rocniVnos(){

        OgradaSet ograda = null;
        VnosPodatkov vnosPodatkov = new VnosPodatkov();

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();

        ograda = hibernate.preberi(OgradaSet.class, 2);

        ograda.dodajZivali(vnosPodatkov.dodajVecZivali());
        ograda.izipisiVseZivali();

        if(ograda.getLokacija() == null){

            Lokacija lokacija = IpApiJersey.mojaLokacija();
            lokacija.setOgradaId(ograda.getId());
            ograda.setLokacija(lokacija);
        }


        hibernate.shrani(ograda);
    }
}
