package si.mojeznanje.model;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import javax.persistence.*;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 * Created by saso on 23. 01. 2018.
 *
 * {
 as: "AS5603 Telekom Slovenije d.d.",
 city: "Ljubljana",
 country: "Slovenia",
 countryCode: "SI",
 isp: "Telekom Slovenije d.d.",
 lat: 46.0364,
 lon: 14.4896,
 org: "Telekom Slovenije d.d.",
 query: "193.77.127.62",
 region: "061",
 regionName: "Ljubljana",
 status: "success",
 timezone: "Europe/Ljubljana",
 zip: ""
 }
 *
 *
 */

@Entity
@Table(name = "lokacija")
@XmlRootElement(name = "query")
@JsonAutoDetect
@JsonIgnoreProperties(ignoreUnknown = true)
public class Lokacija {

    private Integer id;
    private String city;
    private String country;
    private Float lat;
    private Float lon;
    private String zip;
    private String timezone;
    private Integer ogradaId;
    private OgradaSet ograda;

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", unique = true, nullable = false)
    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getCountry() {
        return country;
    }

    public void setCountry(String country) {
        this.country = country;
    }

    public Float getLat() {
        return lat;
    }

    public void setLat(Float lat) {
        this.lat = lat;
    }

    public Float getLon() {
        return lon;
    }

    public void setLon(Float lon) {
        this.lon = lon;
    }

    public String getZip() {
        return zip;
    }

    public void setZip(String zip) {
        this.zip = zip;
    }

    public String getTimezone() {
        return timezone;
    }

    public void setTimezone(String timezone) {
        this.timezone = timezone;
    }

    @Column(name = "ograda_id")
    public Integer getOgradaId() {
        return ogradaId;
    }

    public void setOgradaId(Integer ogradaId) {
        this.ogradaId = ogradaId;
    }

    @XmlTransient
    @JsonIgnore
    @OneToOne(cascade = CascadeType.ALL, fetch = FetchType.EAGER)
    @JoinColumn(name = "ograda_id", insertable = false, updatable = false)
    public OgradaSet getOgrada() {
        return ograda;
    }

    public void setOgrada(OgradaSet ograda) {
        this.ograda = ograda;
    }
}
