package si.mojeznanje.service;

import org.hibernate.Session;
import org.hibernate.query.Query;
import si.mojeznanje.model.Ograda;
import si.mojeznanje.model.OgradaSet;
import si.mojeznanje.model.Zival;
import si.mojeznanje.util.HibernateUtil;

import java.util.Collection;

/**
 * Created by saso on 18. 01. 2018.
 */
public class ZapisovalecHibernate {

    @Deprecated
    public OgradaSet preberi(Integer id){
        Session session = HibernateUtil.getOpenSessionUtf84mb();

        OgradaSet ograda = null;
        try {

            Query query = session.createQuery("from OgradaSet o where o.id = :id");
            query.setParameter("id", id);

            ograda = (OgradaSet) query.uniqueResult();
        }
        catch (Exception e){

            System.out.println("hibernate error");
        }
        session.clear();
        session.close();

        return ograda;
    }

    public <T> T preberi(Class<T> razred, Integer id){
        Session session = HibernateUtil.getOpenSessionUtf84mb();

        T objekt = null;

        try {
            objekt = session.get(razred,id);
        }
        catch (Exception e){
            System.out.println("napaka pri branju");
        }

        session.clear();
        session.close();

        return objekt;

    }
    public void shrani(Object object){
        Session session = HibernateUtil.getOpenSessionUtf84mb();

        try {
            session.beginTransaction();
            session.saveOrUpdate(object);
            session.getTransaction().commit();
        }
        catch (Exception e){
            session.getTransaction().rollback();
            System.out.println("hibernate error");
        }
        session.clear();
        session.close();
    }

    public void izbrisi(Object object){
        Session session = HibernateUtil.getOpenSessionUtf84mb();

        try {
            session.beginTransaction();
            session.delete(object);
            session.getTransaction().commit();
        }
        catch (Exception e){
            session.getTransaction().rollback();
            System.out.println("hibernate error");
        }
        session.clear();
        session.close();
    }

    public <T> void shraniVse(Collection<T> objects){
        Session session = HibernateUtil.getOpenSessionUtf84mb();

        try {

            session.beginTransaction();

            for(Object object : objects){
                session.saveOrUpdate(object);
            }
            session.getTransaction().commit();
        }
        catch (Exception e){
            session.getTransaction().rollback();
            System.out.println("hibernate error");
        }
        session.clear();
        session.close();
    }
}
