package si.mojeznanje.service.datoteka;

import com.fasterxml.jackson.databind.ObjectMapper;

/**
 * Created by Homez on 16/01/2018.
 *
 *  Ta razred nam omogoča shranjevanje raznih objketov v json datotetko
 */
public class ZapisovalecCesarkoli2<T> extends Zapisovalec {

    protected String datoteka = "datoteka.json";

    private Class<T> razred;

    public ZapisovalecCesarkoli2(Class<T> razred){
        this.razred = razred;
    }
    public ZapisovalecCesarkoli2(Class<T> razred, String datoteka){
        this.datoteka = datoteka;
        this.razred = razred;
    }

    /**
     * Ta funkcija shrani objekt v json
     * @param objekt
     * objekt, ki ga zelimo shranit
     */
    public void shrani(T objekt){

        String podatki = "";
        ObjectMapper mapper = new ObjectMapper();

        try {
            podatki = mapper.writeValueAsString(objekt);
        }
        catch (Exception e){
            System.out.println("Napaka pri zapisovanju json");
        }

        shraniDatoteko(podatki, datoteka);
    }

    public T preberi(){

        T objekt = null;

        try {
            objekt = razred.newInstance();
        }
        catch (Exception e){
            System.out.println("Napaka pri kreaciji instance razreda " + razred);
        }

        String podatki = preberiDatoteko(datoteka);

        ObjectMapper mapper = new ObjectMapper();

        try {
            objekt = mapper.readValue(podatki, razred);
        }
        catch (Exception e){
            System.out.println("Napaka pri prebiranju podatkov iz json");
        }

        return objekt;
    }
}
