package si.mojeznanje.service.datoteka;

import com.fasterxml.jackson.databind.ObjectMapper;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

/**
 * Created by saso on 30. 01. 2018.
 */
public class ZapisovalecXML<T>  extends Zapisovalec {

    protected String datoteka = "datoteka.xml";

    private Class<T> razred;

    public ZapisovalecXML(Class<T> razred) {
        this.razred = razred;
    }

    public ZapisovalecXML(Class<T> razred, String datoteka) {
        this.datoteka = datoteka;
        this.razred = razred;
    }

    /**
     * Ta funkcija shrani objekt v xml
     *
     * @param objekt objekt, ki ga zelimo shranit
     */
    public void shrani(T objekt) {

        JAXBContext context = null;


        try(BufferedWriter writer = new BufferedWriter( new FileWriter(datoteka)))
        {

            context = JAXBContext.newInstance(razred);
            Marshaller marshaller = context.createMarshaller();

            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);

            marshaller.marshal(objekt, writer);

        }
        catch (Exception e){

            System.out.println("napaka");
        }
    }

    public T preberi() {

       JAXBContext context = null;

        T objekt = null;

       try {

           context = JAXBContext.newInstance(razred);
           Unmarshaller unmarshaller = context.createUnmarshaller();

            objekt = (T) unmarshaller.unmarshal(new File(datoteka));
       }
       catch (Exception e){

           System.out.println("napaka");
       }

       return objekt;
    }
}
