package si.mojeznanje.service.datoteka;

import si.mojeznanje.model.Zival;
import si.mojeznanje.service.IZapisovalecZivali;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Homez on 09/01/2018.
 */
public class ZapisovalecZivaliCSV extends Zapisovalec implements IZapisovalecZivali {


    protected static final String datoteka = "zivali.txt";

    public void shraniZivali(List<Zival> zivali){

        String podatki = "";

        for (Zival zival : zivali){
            podatki += zival.toCSV() + System.lineSeparator();
        }
        //System.out.println(podatki);

        shraniDatoteko(podatki, datoteka);
    }

    public List<Zival> preberiZivali(){

        List<Zival> zivali = new ArrayList<Zival>();

        String podatki = preberiDatoteko(datoteka);

        //System.out.println(podatki);

        String[] zivalVVrstici = podatki.split(System.lineSeparator());

        for(String vrstica : zivalVVrstici){

            try {
                zivali.add(preberiIzVrstice(vrstica));
            }
            catch (Exception e){
                System.out.println("Napaka pri branju vrstice!");
            }
        }

        return zivali;
    }

    private static Zival preberiIzVrstice(String vrstica) throws Exception{

        String[] podatki = vrstica.split(",");

        Class razredZivali = Class.forName(podatki[0]);
        Zival zival = (Zival)razredZivali.newInstance();

        zival.setIme(podatki[1]);
        zival.setStarost(Integer.parseInt(podatki[2]));
        zival.setSpol(Integer.parseInt(podatki[3]));

        return zival;
    }

}
