package si.mojeznanje.service.rest;


import si.mojeznanje.model.Pes;
import si.mojeznanje.service.ZapisovalecHibernate;

import javax.ws.rs.*;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

/**
 * Created by saso on 25. 01. 2018.
 */
@Path("/zival")
public class ZivaliService {


    /**
     * Dokumentacija metode
     * @param id
     * dokumentacija paramtra
     * @return
     * dokumentacija return vrednosti
     */
    @GET
    @Path("/pes")
    @Produces(MediaType.APPLICATION_JSON)
    public Response getPes(@QueryParam("id") Integer id){

        Pes pes = null;

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();

        pes = hibernate.preberi(Pes.class,id);

        if(pes == null){
            return Response.noContent().build();
        }

        return Response.ok(pes).build();
    }


    @GET
    @Path("/pes/{id}")
    @Produces(MediaType.APPLICATION_XML)
    public Response getPesPath(@PathParam("id") Integer id){

        Pes pes = null;

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();

        pes = hibernate.preberi(Pes.class,id);

        if(pes == null){
            return Response.noContent().build();
        }

        return Response.ok(pes).build();
    }

    @POST
    @Path("/pes")
    @Produces(MediaType.APPLICATION_JSON)
    public Response shraniPsa(Pes pes){

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();
        hibernate.shrani(pes);

        return Response.ok(pes).build();
    }

    @DELETE
    @Path("/pes")
    @Produces(MediaType.TEXT_PLAIN)
    public Response izbrisiPsa(@QueryParam("id") Integer id){

        ZapisovalecHibernate hibernate = new ZapisovalecHibernate();
        Pes pes = hibernate.preberi(Pes.class, id);
        hibernate.izbrisi(pes);
        return Response.ok("Izbrisano").build();
    }
}
