package si.mojeznanje.util;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.boot.Metadata;
import org.hibernate.boot.MetadataSources;
import org.hibernate.boot.registry.StandardServiceRegistry;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
import org.hibernate.jdbc.ReturningWork;

import java.sql.SQLException;
import java.sql.Statement;


/**
 * Created by Saso on 8.3.2014.
 */
@SuppressWarnings("ALL")
public class HibernateUtil
{
    private static  SessionFactory sessionFactory = buildSessionFactory();


    public static Session getOpenSessionUtf84mb()
    {
        Session session = getSessionFactory().openSession();
        session.doReturningWork(new ReturningWork<Object>()
        {
            @Override
            public Object execute(java.sql.Connection conn) throws SQLException
            {
                try{
                    Statement stmt = conn.createStatement();
                    stmt.executeQuery("SET NAMES utf8mb4");
                }
                catch (Exception e)
                {

                }

                return null;
            }
        });

        return session;
    }

    public static Session getOpenSession()
    {
        return getSessionFactory().openSession();
    }
    private static SessionFactory buildSessionFactory() {


        try {
            // Create the SessionFactory from hibernate.cfg.xml
            StandardServiceRegistry standardRegistry =
                    new StandardServiceRegistryBuilder() .configure("hibernate.cfg.xml").build();
            Metadata metadata = new MetadataSources(standardRegistry).getMetadataBuilder().build();
            SessionFactory factory = metadata.getSessionFactoryBuilder().build();
            return factory;

        }
        catch (Throwable ex) {
            throw new ExceptionInInitializerError(ex);
        }
    }

    public static SessionFactory getSessionFactory() {

        if(sessionFactory == null)
        {
            sessionFactory = buildSessionFactory();
        }
        if(sessionFactory.isClosed())
        {
            sessionFactory = buildSessionFactory();

            log("session factory is closed");

        }

        return sessionFactory;
    }

    public static void shutdown() {
        // Close caches and connection pools

        getSessionFactory().close();
        sessionFactory = null;

    }

    protected static void log(String string)
    {

    }
}
