package si.mojeznanje.view;

import si.mojeznanje.model.*;
import si.mojeznanje.model.tipi.TipZivali;

import java.beans.PersistenceDelegate;
import java.util.ArrayList;
import java.util.Scanner;

//saso.pompe@gmail.com
//https://we.tl/eRwvCNk6ot
public class VnosPodatkov {

    public static final String DA = "da";
    public static final String NE = "ne";

    public static final String MOSKI = "M";
    public static final String ZENSKI = "Z";

    Scanner scanner = new Scanner(System.in);

    public ArrayList<Zival> dodajVecZivali(){

        ArrayList<Zival> zivali = new ArrayList<Zival>();
        Boolean dodajSeEnoZival = true;
        do {
            System.out.println("Ali zelite dodati zival?");
            String odgovor = scanner.nextLine();

            if (odgovor.equals(DA)) {

                Zival zival = dodajZival();
                zivali.add(zival);

            } else if (odgovor.equals(NE)) {
                dodajSeEnoZival = false;
            } else {
                System.out.println("To ni pravilen odgovor!");
            }
        }
        while (dodajSeEnoZival);

        return zivali;
    }
    public Zival dodajZival() {
        System.out.println("Vpisite ime zivali");
        String ime = scanner.nextLine();
        Integer starost = pridobiStarostZivali(ime);
        Integer spol = poskusanjPridobitiSpol(ime);

        Zival zival = null;

        String tip = pridobiTipZivali();

        if (tip.equals(TipZivali.PES.getTip())) {
            zival = new Pes();
        }
        else if (tip.equals(TipZivali.MACKA.getTip()))
        {
            zival = new Macka();
        }
        else if(tip.equals(TipZivali.RIBA.getTip()))
        {
            zival = new Riba();
        }



        zival.setIme(ime);
        zival.setStarost(starost);


        try {
            zival.setSpol(spol);
        }
        catch (Exception e)
        {
            System.out.println(e.getMessage());
        }

        if(zival instanceof IKosmatinec)
        {
            ((IKosmatinec)zival).pobozajMe();
        }

        return zival;
    }

    public String pridobiTipZivali()
    {
        while (true){
            System.out.println("Vpisite tip zivali : ");
            String odgovor = scanner.nextLine();

            if(odgovor.equals(TipZivali.PES.getTip()) ||
                    odgovor.equals(TipZivali.MACKA.getTip()) ||
                    odgovor.equals(TipZivali.RIBA.getTip())){

                return odgovor;
            }
        }
    }

    public Integer poskusanjPridobitiSpol(String imeZivali){

      while (true){

          System.out.println("Vpisite spol " + imeZivali + " : " + MOSKI + " | " + ZENSKI);
          String odgovor = scanner.nextLine();

          if(odgovor.equals(MOSKI))
          {
              return Zival.MOSKI;
          }
          else if(odgovor.equals(ZENSKI))
          {
              return Zival.ZENSKI;
          }
      }
    }

    public Integer pridobiStarostZivali(String imeZivali){

        Boolean poskusajDobitiStarost = true;
        Integer starostZivali = 0;

        while (poskusajDobitiStarost) {
            System.out.println("Vpišite starost živali " + imeZivali + " :");

            try {
                String age = scanner.nextLine();
                starostZivali = Integer.parseInt(age);
                poskusajDobitiStarost = false;

            } catch (Exception e) {

                System.out.println("Vnešena vrednost ni število.");
                poskusajDobitiStarost = true;
            }
        }

        return starostZivali;
    }

    public ArrayList<Integer> najdiPrvi2StarostiNad10Let(Integer[] starosti)
    {
        ArrayList<Integer> starostiNad10Let = new ArrayList<Integer>();

        for(Integer starost : starosti)
        {
            if(starost <= 10)
            {
                continue;
            }

            starostiNad10Let.add(starost);

            if(starostiNad10Let.size() == 2){
                break;
            }
        }

        return starostiNad10Let;
    }
}
